package com.alibaba.druid.sql.dialect.db2.ast.stmt.alterTable;

import com.alibaba.druid.sql.ast.SQLExpr;
import com.alibaba.druid.sql.ast.statement.SQLAlterTableItem;
import com.alibaba.druid.sql.dialect.db2.ast.DB2SQLObject;
import com.alibaba.druid.sql.dialect.db2.ast.DB2SQLObjectImpl;
import com.alibaba.druid.sql.dialect.db2.visitor.DB2ASTVisitor;
import com.alibaba.druid.sql.visitor.SQLASTVisitor;

public class DB2AlterTableDropConstraint extends DB2SQLObjectImpl implements SQLAlterTableItem, DB2SQLObject {
   private SQLExpr constraint;
   private boolean ifExists;
   private DorpType type;

   public SQLExpr getConstraint() {
      return this.constraint;
   }

   public void setConstraint(SQLExpr constraint) {
      this.constraint = constraint;
      constraint.setParent(this);
   }

   public boolean isIfExists() {
      return this.ifExists;
   }

   public void setIfExists(boolean ifExists) {
      this.ifExists = ifExists;
   }

   public DorpType getType() {
      return this.type;
   }

   public void setType(DorpType type) {
      this.type = type;
   }

   public void accept0(SQLASTVisitor visitor) {
      this.accept0((DB2ASTVisitor)visitor);
   }

   public void accept0(DB2ASTVisitor visitor) {
      if (visitor.visit(this)) {
         this.constraint.accept(visitor);
      }

      visitor.endVisit(this);
   }

   public DB2AlterTableDropConstraint clone() {
      DB2AlterTableDropConstraint c = new DB2AlterTableDropConstraint();
      c.setConstraint(this.constraint.clone());
      c.type = this.type;
      c.ifExists = this.ifExists;
      return c;
   }

   public static enum DorpType {
      restrict,
      cascade;
   }
}
